# -*- encoding: utf-8 -*-
# stub: y_petri 2.4.9 ruby lib

Gem::Specification.new do |s|
  s.name = "y_petri".freeze
  s.version = "2.4.9"

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib".freeze]
  s.authors = ["boris".freeze]
  s.date = "2016-07-13"
  s.description = "YPetri is a DSL (domain-specific language) for modelling of dynamical systems. It is biologically inspired, but concerns of biology and chemistry have been purposely separated away from it. YPetri caters solely to the two main concerns of modelling, model specification and simulation, and it excels in the first one. Dynamical systems are described under a Petri net paradigm. YPetri implements a universal Petri net abstraction that integrates discrete/continous, timed/timeless and stoichiometric/nonstoichiometric dichotomies of the extended Petri nets, and allows efficient specification of any kind of dynamical system. Like Petri nets themselves, YPetri was inspired by problems from the domain of chemistry (biochemical pathway modelling), but is not specific to it. Other gems, YChem and YCell are planned to cater to the concerns specific to chemistry and cell biochemistry. A lower-level extension of YPetri is currently under development under the name YNelson. Its usage is practically identical to YPetri, so any YPetri user can now consider using YNelson instead. YNelson covers additional concerns: it allows relations among nodes and parameters to be specified under a zz structure paradigm (developed by Ted Nelson) and it is also aimed towards providing a higher level of abstraction in Petri net specification by providing commands that create more than one Petri net node per command. YPetri documentation is avalable online, but due to formatting issues, you may prefer to generate the documentation on your own by running rdoc in the gem directory. As for the user manuals, there are currently 3 documents applicable for both YPetri and YNelson, whose master copies are stored in the YNelson source directory: 1. Introduction to YNelson and YPetri (hands-on tutorial), 2. Object model of YNelson and YPetri, 3. Introduction to Ruby for YNelson users. These manuals are written to allow beginners, including those unfamiliar with Ruby, to start working with YPetri and/or YNelson. For an example of how YPetri can be used to model complex dynamical systems, see the eukaryotic cell cycle model which I released as \"cell_cycle\" gem.".freeze
  s.email = ["\"boris@iis.sinica.edu.tw\"".freeze]
  s.homepage = "".freeze
  s.licenses = ["GPLv3".freeze]
  s.required_ruby_version = Gem::Requirement.new(">= 2.0".freeze)
  s.rubygems_version = "3.2.22".freeze
  s.summary = "Systems modelling and simulation gem. Biologically inspired, but concerns specific to biology and chemistry have been purposely separated away from it, so it is a general-purpose model specification and simulation DSL. Dynamical systems are specified by a specific universal type of a hybrid Petri net which YPetri implements and which allows description of any kind of dynamical system whatsoever.".freeze

  s.installed_by_version = "3.2.22" if s.respond_to? :installed_by_version

  if s.respond_to? :specification_version then
    s.specification_version = 4
  end

  if s.respond_to? :add_runtime_dependency then
    s.add_development_dependency(%q<bundler>.freeze, ["~> 1.6"])
    s.add_development_dependency(%q<rake>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<y_support>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<gnuplot>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<ruby-graphviz>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<distribution>.freeze, [">= 0"])
  else
    s.add_dependency(%q<bundler>.freeze, ["~> 1.6"])
    s.add_dependency(%q<rake>.freeze, [">= 0"])
    s.add_dependency(%q<y_support>.freeze, [">= 0"])
    s.add_dependency(%q<gnuplot>.freeze, [">= 0"])
    s.add_dependency(%q<ruby-graphviz>.freeze, [">= 0"])
    s.add_dependency(%q<distribution>.freeze, [">= 0"])
  end
end
